/* 
  irq.c

  schedule and recognize interrupts

  we maintain a priority queue of interrupts, recognizing each as soon
  as possible.  we maintain the queue in a skip list to speed insertion.


$Log$

*/

#include <stdio.h>
#include "skip.h"

int int_cmp(int a, int b)
{
    return a-b;
}

static skip_list intq;

init_irq()
{
    intq = create_list_with_ops(int_cmp, NULL, NULL, NULL,
				NULL, NULL, NULL);
}

void schedule_interrupt(int n, long t)
{
    (void) insert(intq, (void *) t, (value) n, 0);
}

int interrupt_pending(long t)
{
    return ((long) first_key(intq) <= t);
}

int first_interrupt()
{
    value level;
    find(intq, first_key(intq), &level);
    delete(intq, first_key(intq));
    return level;
}

      

