/***************************************************************
 * defs.h -- This file contains definitions for constants and  *
 *           global variables.  It is used for CS273's Sim6811 *
 *                                                             *
 *                  written by Rob Sinclair                    *
 *                   rsinclai@cs.nmsu.edu                      *
 ***************************************************************/

#ifndef SIM_CONST_DEF
#define SIM_CONST_DEF

/****************************************************************
 * Constants for the Sim6811 Simulator.                         *
 ****************************************************************/
#define ASCII              0
#define DECIMAL            1
#define HEX                2
#define OCTAL              3
#define SIGNED_BINARY      4
#define UNSIGNED_BINARY    5

#define MEMORY      10
#define IO_PORTS    11
#define STACK       12

#define FILE_CLOSE  20
#define FILE_OPEN   21
#define FILE_PRINT  22
#define FILE_ASM_N  23
#define FILE_ASM_Y  24
#define FILE_EXIT   25

#define USERS_GUIDE_FILE       "/usr/unsupported/src/Sim6811/UsersGuide.html"
#define ASSEMBLY_REFERENCE     "/usr/unsupported/src/Sim6811/AssemblyRef.html"
#define PROGRAMMERS_REFERENCE  "/usr/unsupported/src/Sim6811/ProgramRef.html"
#define NEW_FEATURES           "/usr/unsupported/src/Sim6811/NewFeatures.html"

/*
#define USERS_GUIDE_FILE       "http://www.cs.nmsu.edu:80/~rsinclai/public_html/Sim6811/UsersGuide.html"
#define ASSEMBLY_REFERENCE     "http://www.cs.nmsu.edu:80/~rsinclai/public_html/Sim6811/AssemblyRef.html"
#define PROGRAMMERS_REFERENCE  "http://www.cs.nmsu.edu:80/~rsinclai/public_html/Sim6811/ProgramRef.html"
*/

/****************************************************************
 * Constants for Windows                                        *
 ****************************************************************/
/*
#define  WIN_MAIN        Sim6811_win->Sim6811_sim6811Window
#define  WIN_SOURCECODE  Sim6811_win->Sim6811_winSourceCode
#define  WIN_CROSSREFS   Sim6811_win->Sim6811_winCrossRef
#define  WIN_CIRCUITBRD  Sim6811_win->Sim6811_winCircuitBoard
#define  WIN_MEMORY      Sim6811_win->Sim6811_winMemory
#define  WIN_REGISTERS   Sim6811_win->Sim6811_winRegisters
#define  WIN_STACK       Sim6811_win->Sim6811_winStack
#define  WIN_SYMBOLTAB   Sim6811_win->Sim6811_winSymbolTable
#define  WIN_OUTPUT      Sim6811_win->Sim6811_winOutput
#define  WIN_EDITMEM     Sim6811_win->Sim6811_winEditMemory
*/
#define  WIN_MAIN        100
#define  WIN_SOURCECODE  101
#define  WIN_CROSSREFS   102
#define  WIN_CIRCUITBRD  103
#define  WIN_MEMORY      104
#define  WIN_REGISTERS   105
#define  WIN_STACK       106
#define  WIN_SYMBOLTAB   107
#define  WIN_OUTPUT      108
#define  WIN_EDITMEM     109
#define  WIN_BREAKPTS    110
#define  STDOUT          201
#define  STDERR          202

#ifdef DEBUGGING
/* Turn debugging output on */
#define DEBUG(command)  command; fflush(stderr);
#else
/* Turn debugging output off */
#define DEBUG(command)
#endif /* DEBUGGING */

#define ASM_FILE(file)  (strcmp(file+(strlen(file)-4), ".asm") == 0)

#endif /* SIM_CONST_DEF */
